;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |          Controllo display per 877           |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 31/03/09                       |
; |______________________________________________|


;_______________________________________________________Inizializza display
;Routine di inizializzazione dei display
;Registri modificati:
;       Sistema
;       b_SEG_SELECT
;       l_DISP1_DATA
;       l_DISP2_DATA
;       b_DATA
;       b_ADDRESS
Disp_Init:
        MOVLF c_SEG_PWR_INIT,b_SEG_SELECT   ;Inizializza stato segmenti
        MOVLW CHAR_VOID                     ;Carica carattere nullo
        MOVWF l_DISP1_DATA                  ;Imposta display display
        MOVWF l_DISP1_DATA+1                ;
        MOVWF l_DISP1_DATA+2                ;
        MOVWF l_DISP1_DATA+3                ;
        MOVWF l_DISP2_DATA                  ;
        MOVWF l_DISP2_DATA+1                ;
        MOVWF l_DISP2_DATA+2                ;
        MOVWF l_DISP2_DATA+3                ;
        MOVFF b_SEG_SELECT,b_DATA           ;carica stato segmenti
        MOVLF c_ADDR_DSEL,b_ADDRESS         ;seleziona indirizzo
        CALL IO_WRTDATA                     ;scrive sul buffer selezione display
        MOVLF CHAR_VOID,b_DATA              ;carica carattere nullo
        MOVLF c_ADDR_DDATA,b_ADDRESS        ;seleziona indirizzo
        CALL IO_WRTDATA                     ;scrive sul buffer dato display
        CLRF l_DISP_BUF1                    ;
        MOVLF .19,l_DISP_BUF1               ;carica dimensione buffer
        MOVLF l_DISP_BUF1+1,FSR             ;carica indirizzo iniziale dei buffer
Disp_I1 MOVLF 0XFF,INDF                     ;pulisce buffer
        INCF FSR,f                          ;
        DECFSZ l_DISP_BUF1,f                ;
        GOTO Disp_I1                        ;
        CLRF l_DISP_BUF1                    ;ha finito
        CLRF w_DISP_STAT                    ;
        CLRF w_DISP_STAT+1                  ;
        RETURN

;_______________________________________________________Visualizzazione
;Routine di gestione dei dati in sincrono con il segmento attivo
;Registri modificati:
;       Sistema
;       b_DISP_STAT
;       b_SEG_SELECT
;       b_DATA
;       b_ADDRESS
Disp_Write:
        MOVLW l_DISP1_DATA                  ;carica indirizzo iniziale del blocco dati
        ADDWF w_DISP_STAT,w                 ;aggiunge offset selezione segmento
        MOVWF FSR                           ;carica indirizzo in FSR
        MOVFF INDF,b_DATA                   ;copia il segmento da visualizzare
        MOVLF c_ADDR_DDATA,b_ADDRESS        ;seleziona indirizzo dati display
        CALL IO_WRTDATA                     ;scrive il dato
        MOVFF b_SEG_SELECT,b_DATA           ;carica selezione segmenti
        MOVLF c_ADDR_DSEL,b_ADDRESS         ;seleziona indirizzo controllo display
        CALL IO_WRTDATA                     ;scrive il dato
        BTFSS f_DISP_END                    ;controlla se ha attivato tutti i segmenti
        GOTO Disp_W1                        ; si
        INCF w_DISP_STAT,f                  ;no, seleziona prossimo segmento da visualizzare
        SETC                                ;cambia segmenti da attivare
        RLF b_SEG_SELECT,f                  ;
;VERIFICA CHE IL BUFFER NON SI SIA IN CASINO
        MOVF w_DISP_STAT,w                  ;
        XORLW .6                            ;
        BZ Disp_W1                          ;
        BTFSS b_SEG_SELECT,6                ;
        GOTO Disp_W1                        ;
        BTFSS b_SEG_SELECT,7                ;
        GOTO Disp_W1                        ;
        RETURN                              ;no, esce
Disp_W1 MOVLF c_SEG_PWR_INIT,b_SEG_SELECT   ;si, riparte dall'inizio
        CLRF w_DISP_STAT                    ;
        RETURN

;_______________________________________________________Scorrimento 1
;Visualizza dei dati in scorrimento sul display 1
;Dati in ingresso
;       su R0H va inserita la dimensione dell'area dati (max 20)
;       su l_DISP_BUF vanno inseriti i dati
;Registri modificati:
;       Sistema
;       l_DISP1_DATA
;       b_DATA
;       b_ADDRESS
;       R0L
Disp1_Shift:
        MOVLW l_DISP_BUF1                   ;carica indirizzo iniziale del blocco dati
        ADDWF R0L,w                         ;aggiunge offset selezione segmento
        MOVWF FSR                           ;carica indirizzo primo digit in FSR
        MOVFF INDF,l_DISP1_DATA             ;copia i dati
        INCF FSR,f                          ;secondo digit
        MOVFF INDF,l_DISP1_DATA+1           ;copia i dati
        INCF FSR,f                          ;terzo digit
        MOVFF INDF,l_DISP1_DATA+2           ;copia i dati
        INCF R0L,f                          ;
        DECF R0H,f                          ;
        DECF R0H,f                          ;
        COMF R0L,w                          ;
        ANDWF R0H,w                         ;controlla se finito il giro
        BNZ Dis1_S1                         ; no
        CLRF R0L                            ; si, ricomincia
Dis1_S1 INCF R0H,f                          ;
        INCF R0H,f                          ;
        RETURN

;_______________________________________________________Hash table display
;Conversione valore BCD per display
;ATTENZIONE!!!!!! Evitare assolutamente di farla finire a cavallo tra due
; blocchi di 256 bytes. Usare preferibilmente la direttiva ORG dell'IDE.
; Va chiamata in questo modo:
;       INCF DATO,w                     ;incrementa il dato per tenere conto
;                                       ; della istruzione di caricamento
;       CALL Tar_Dset                   ;chiama la sub
;       MOVWF <display>                 ;imposta digit display
;Dati in ingresso
;       WREG = valore numerico (1-16)
;Dati in uscita
;       WREG = valore da caricare sul display
;Registri modificati:
;       Sistema
Disp_Bcd:

	ADDWF PCL,f
        RETLW CHAR_0                    ;restituisce "0"
        RETLW CHAR_1                    ;restituisce "1"
        RETLW CHAR_2                    ;restituisce "2"
        RETLW CHAR_3                    ;restituisce "3"
        RETLW CHAR_4                    ;restituisce "4"
        RETLW CHAR_5                    ;restituisce "5"
        RETLW CHAR_6                    ;restituisce "6"
        RETLW CHAR_7                    ;restituisce "7"
        RETLW CHAR_8                    ;restituisce "8"
        RETLW CHAR_9                    ;restituisce "9"
        RETLW CHAR_A                    ;restituisce "A"
        RETLW CHAR_B                    ;restituisce "B"
        RETLW CHAR_C                    ;restituisce "C"
        RETLW CHAR_D                    ;restituisce "D"
        RETLW CHAR_E                    ;restituisce "E"
        RETLW CHAR_F                    ;restituisce "F"
        RETURN
