;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |          Sub gestione I/O per 877            |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 10/03/09                       |
; |______________________________________________|

;_______________________________________________________Inizializza bus
; Routine di init degli I/O. Imposta i valori dei TRIS e azzera le variabili
;Registri modificati:
;       Sistema
;       b_DATA
;       b_ADDRESS
IO_Init:
        BANKSEL TRISA                       ;BANK1
        MOVLF c_TRISA_VALUE,TRISA           ; imposta PORTA
        MOVLF c_TRISB_VALUE,TRISB           ; imposta PORTB
        MOVLF c_TRISC_VALUE,TRISC           ; imposta PORTC
        MOVLF c_TRISDI_VALUE,TRISD          ; imposta PORTD in ingresso
        MOVLF c_TRISE_VALUE,TRISE           ; imposta PORTE
        BANKSEL PORTA                       ;BANK0
        CLRF PORTA
        CLRF PORTB
        CLRF PORTC
        CLRF PORTD
        CLRF PORTE
        CLRF b_DATA                         ;azzera byte dati
        CLRF b_ADDRESS                      ;azzera indirizzi
        CALL IO_CLRADD                      ;imposta indirizzi sul buffer
        CLRF b_DATA                         ;
        MOVLF c_ADDR_OUT,b_ADDRESS          ;
        CALL IO_WRTDATA                     ;
        RETURN

;_______________________________________________________Scrive indirizzo
; Imposta l'indirizzo di 4 bit sui pin corretti in uscita.
;Dati in ingresso:
;       b_ADDRESS = indirizzo da selezionare
;Registri modificati:
;       Sistema
IO_SETADD:
        MOVF c_S0_PORT,w                    ;maschera per pulire
        ANDLW c_ADDR0_MASK                  ;
        MOVWF c_S0_PORT                     ;
        BTFSC f_S0_BIT                      ;controlla se S0=1
        BSF c_S0_PORT,c_S0_PIN              ; SI, imposta pin
        BTFSC f_S1_BIT                      ;NO, controlla se S1=1
        BSF c_S1_PORT,c_S1_PIN              ; SI, imposta pin
        BTFSC f_S2_BIT                      ;NO, controlla se S2=1
        BSF c_S2_PORT,c_S2_PIN              ; SI, imposta pin
        BTFSC f_S3_BIT                      ;NO, controlla se S3=1
        BSF c_S3_PORT,c_S3_PIN              ; SI, imposta pin
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        NOP
        NOP
        NOP
        NOP
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        RETURN

;_______________________________________________________Torna a indirizzo 0
; Imposta l'indirizzo di 4 bit sui pin corretti in uscita.
;Dati in ingresso:
;       (n/a)
;Registri modificati:
;       Sistema
IO_CLRADD:
        MOVF c_S0_PORT,w                    ;maschera per pulire
        ANDLW c_ADDR0_MASK                  ;
        MOVWF c_S0_PORT                     ;
        RETURN

;_______________________________________________________Colpo di clock
; Da un colpo di clock su CK.
;Registri modificati:
;       Sistema
IO_CLK:
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin
        NOP
        NOP
        NOP
        NOP
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin
        RETURN

;_______________________________________________________Scrive dato
; Consegna il byte b_DATA all'indirizzo b_ADDRESS
;Dati in ingresso:
;       b_DATA = dato da inviare
;       b_ADDRESS = indirizzo da selezionare
;Registri modificati:
;       Sistema
IO_WRTDATA:
        BANKSEL TRISD                       ;BANK1
        MOVLF c_TRISDO_VALUE,TRISD          ; imposta bus dati in uscita
        BANKSEL PORTD                       ;BANK0
        MOVFF b_DATA,PORTD                  ;carica il dato sul bus
        CALL IO_SETADD                      ;Seleziona indirizzo
        BCF c_OE_PORT,c_OE_PIN              ;attiva OE indirizzi
        NOP
        NOP
        NOP
        NOP
        BSF c_OE_PORT,c_OE_PIN              ;disattiva OE indirizzi
        CALL IO_CLRADD                      ;Azzera indirizzo
        BANKSEL TRISD                       ;BANK1
        MOVLF c_TRISDI_VALUE,TRISD          ; imposta bus dati in ingresso
        BANKSEL PORTD                       ;BANK0
        RETURN

;_______________________________________________________Legge dato
; Legge dall'indirizzo b_ADDRESS e scrive il dato in b_DATA
;Dati in ingresso:
;       b_ADDRESS = indirizzo da selezionare
;Registri modificati:
;       Sistema
;       b_DATA
IO_RDDATA:
        BANKSEL b_DATA
        BCF INTCON,GIE                      ;Disabilita tutti gli IRQ
        CALL IO_SETADD                      ;Seleziona indirizzo
        CALL IO_CLK                         ;Clock per refresh dato
        BCF c_OE_PORT,c_OE_PIN              ;attiva OE indirizzi
        NOP
        NOP
        NOP
        NOP
        MOVFF PORTD,b_DATA                  ;copia il dato
        BSF c_OE_PORT,c_OE_PIN              ;disattiva OE indirizzi
        BSF INTCON,GIE                      ;Riabilita tutti gli IRQ
        RETURN
