;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |         Controllo tastiera per 877           |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 31/03/09                       |
; |______________________________________________|

;_______________________________________________________Init della tastiera
; Routine di init della tastiera. Azzera le variabili
;Registri modificati:
;       Sistema
;       b_KEYB_STAT
;       b_SWITCH_11
;       b_SWITCH_12
;       b_SWITCH_13
;       b_SWITCH_14
Keyb_Init:
        CLRF b_KEYB_STAT
        MOVLF 0x01,b_SWITCH_11
        MOVWF b_SWITCH_12
        MOVWF b_SWITCH_13
        MOVWF b_SWITCH_14
        RETURN


;_______________________________________________________Legge tastiera
; Imposta I/O e legge la tastiera
;Dati in ingresso:
;       (n/a)
;Registri modificati:
;       Sistema
;       b_KEYB_STAT
;       b_SWITCH_11
;       b_SWITCH_12
;       b_SWITCH_13
;       b_SWITCH_14
Keyb_Read:
        BANKSEL TRISD                       ;BANK1
        MOVLF c_TRISDK_VALUE,TRISD          ; imposta D0-D3 come OUT, D4-D7 come IN
        BANKSEL PORTD                       ;BANK0
        BCF c_S0_PORT,c_S0_PIN              ;imposta indirizzo tastiera
        BSF c_S1_PORT,c_S1_PIN
        BCF c_S2_PORT,c_S2_PIN
        BCF c_S3_PORT,c_S3_PIN

        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        BCF c_OE_PORT,c_OE_PIN              ;attiva OE indirizzi
        ;indirizzo impostato
KR_S1_0 MOVLF 0x01,PORTD                    ;carica posizione colonna 1
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;colonna impostata
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;dato valido
        BTFSC PORTD,4                       ;controlla se SW11 premuto
        GOTO KR_S1_1                        ; si
        DECFSZ b_SWITCH_11,f                ; no, decrementa buffer
        GOTO KR_S2_0                        ;  non e' a zero, prosegue
        INCF b_SWITCH_11,f                  ;  e' a zero, incrementa di 1
        BTFSC f_SW_11P                      ;controlla se era gia' "non premuto"
        BCF f_SW_11P                        ; no, imposta condizione
        GOTO KR_S2_0                        ;prosegue
KR_S1_1 INCF b_SWITCH_11,f                  ;incrementa di 1
        BTFSS b_SWITCH_11,c_KEYB_BIT        ;controlla se buffer pieno
        GOTO KR_S2_0                        ; no, prosegue
        DECF b_SWITCH_11,f                  ; si, decrementa di 1
        CLRF b_SWITCH_11                    ;al posto di decrementare svuota
        BTFSS f_SW_11P                      ;controlla se era gia' "premuto"
        BSF f_SW_11P                        ; no, imposta condizione
        BSF f_SW_11                         ;
KR_S2_0 MOVLF 0x02,PORTD                    ;carica posizione colonna 2
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;colonna impostata
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;dato valido
        BTFSC PORTD,4                       ;controlla se SW12 premuto
        GOTO KR_S2_1                        ; si
        DECFSZ b_SWITCH_12,f                ; no, decrementa buffer
        GOTO KR_S3_0                        ;  non e' a zero, prosegue
        INCF b_SWITCH_12,f                  ;  e' a zero, incrementa di 1
        BTFSC f_SW_12P                      ;controlla se era gia' "non premuto"
        BCF f_SW_12P                        ; no, imposta condizione
        GOTO KR_S3_0                        ;prosegue
KR_S2_1 INCF b_SWITCH_12,f                  ;incrementa di 1
        BTFSS b_SWITCH_12,c_KEYB_BIT        ;controlla se buffer pieno
        GOTO KR_S3_0                        ; no, prosegue
        DECF b_SWITCH_12,f                  ; si, decrementa di 1
        CLRF b_SWITCH_12                    ;al posto di decrementare svuota
        BTFSS f_SW_12P                      ;controlla se era gia' "premuto"
        BSF f_SW_12P                        ; no, imposta condizione
        BSF f_SW_12                         ;
KR_S3_0 MOVLF 0x04,PORTD                    ;carica posizione colonna 3
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;colonna impostata
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;dato valido
        BTFSC PORTD,4                       ;controlla se SW13 premuto
        GOTO KR_S3_1                        ; si
        DECFSZ b_SWITCH_13,f                ; no, decrementa buffer
        GOTO KR_S4_0                        ;  non e' a zero, prosegue
        INCF b_SWITCH_13,f                  ;  e' a zero, incrementa di 1
        BTFSC f_SW_13P                      ;controlla se era gia' "non premuto"
        BCF f_SW_13P                        ; no, imposta condizione
        GOTO KR_S4_0                        ;prosegue
KR_S3_1 INCF b_SWITCH_13,f                  ;incrementa di 1
        BTFSS b_SWITCH_13,c_KEYB_BIT        ;controlla se buffer pieno
        GOTO KR_S4_0                        ; no, prosegue
        DECF b_SWITCH_13,f                  ; si, decrementa di 1
        BTFSS f_SW_13P                      ;controlla se era gia' "premuto"
        BSF f_SW_13                         ; no, imposta condizione
        BSF f_SW_13P                        ;

KR_S4_0 MOVLF 0x08,PORTD                    ;carica posizione colonna 4
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;colonna impostata
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;dato valido
        BTFSC PORTD,4                       ;controlla se SW14 premuto
        GOTO KR_S4_1                        ; si
        DECFSZ b_SWITCH_14,f                ; no, decrementa buffer
        GOTO KR_S4_0                        ;  non e' a zero, prosegue
        INCF b_SWITCH_14,f                  ;  e' a zero, incrementa di 1
        BTFSC f_SW_14P                      ;controlla se era gia' "non premuto"
        BCF f_SW_14P                        ; no, imposta condizione
        GOTO KR_SE_0                        ;prosegue
KR_S4_1 INCF b_SWITCH_14,f                  ;incrementa di 1
        BTFSS b_SWITCH_14,c_KEYB_BIT        ;controlla se buffer pieno
        GOTO KR_SE_0                        ; no, prosegue
        DECF b_SWITCH_14,f                  ; si, decrementa di 1
        BTFSS f_SW_14P                      ;controlla se era gia' "premuto"
        BSF f_SW_14                         ; no, imposta condizione
        BSF f_SW_14P                        ;
KR_SE_0 CLRF PORTD                          ;azzera uscite
        BSF c_CK_PORT,c_CK_PIN              ;alza il pin clock
        BCF c_CK_PORT,c_CK_PIN              ;abbassa il pin clock
        ;port impostato
        BCF c_S1_PORT,c_S1_PIN              ;riporta ad "idle" l'indirizzo
        BCF c_OE_PORT,c_OE_PIN              ;disattiva OE indirizzi
        RETURN
