;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |            Controllo PWM per 877             |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 31/03/09                       |
; |______________________________________________|

;_______________________________________________________Inizializza PWM
PWM_Init:
        BANKSEL PR2                         ;
        MOVLF c_PR2_VALUE,PR2               ;imposta periodo PWM
        BANKSEL CCPR1L                      ;
        MOVLF c_PWM_IDLE,b_PWM_STAT         ;Posizione di riposo Bridge
        MOVFF b_PWM_STAT,b_DATA             ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        CLRF CCPR1L                         ;imposta Duty PWM a 0
        CLRF T2CON                          ;Imposta timer2 (no pre/post scaler)
        BSF T2CON,TMR2ON                    ;Attiva timer2
        MOVLF c_CCP1CON_VALUE,CCP1CON       ;Abilita modalita' PWM
        CLRF b_SYN_CTRL                     ;Pulisce status sinusoide
        BSF b_SYN_CTRL,0                    ;Imposta stato iniziale
        CLRF b_PWM_DATA1                    ;
        CLRF b_PWM_DATA2                    ;
        CLRF b_PWM_DATA3                    ;
        RETURN

;_______________________________________________________Uscita PWM Positiva AC
;Imposta lo switcher su uscita AC positiva.
;ATTENZIONE: con questa impostazione occorre mantenere un alternanza
; pos/neg almeno ogni 20ms per evitare lo spegnimento dei drivers
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_DATA
;       b_ADDRESS
PWM_ACPos:
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        MOVLF c_PWM_ACPVAL,b_PWM_STAT       ;Imposta stato su AC Positiva
        MOVWF b_DATA                        ;Carica il dato
        CALL IO_WRTDATA                     ;Scrive sul buffer
        RETURN

;_______________________________________________________Uscita PWM Negativa AC
;Imposta lo switcher su uscita AC negativa.
;ATTENZIONE: con questa impostazione occorre mantenere un alternanza
; pos/neg almeno ogni 20ms per evitare lo spegnimento dei drivers
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_DATA
;       b_ADDRESS
PWM_ACNeg:
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        MOVLF c_PWM_ACNVAL,b_PWM_STAT       ;Imposta stato su AC Negativa
        MOVWF b_DATA                        ;Carica il dato
        CALL IO_WRTDATA                     ;Scrive sul buffer
        RETURN

;_______________________________________________________Uscita PWM AC disattivata
;Imposta lo switcher su uscita AC nulla (serve a ridare il colpo ai driver.
;ATTENZIONE: con questa impostazione occorre mantenere un alternanza
; pos/neg almeno ogni 20ms per evitare lo spegnimento dei drivers
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_DATA
;       b_ADDRESS
PWM_ACClr:
        BCF f_PWM_AC_INV                    ;Clear flag cambio polarita'
        MOVLF c_PWM_ACCVAL,b_PWM_STAT       ;Imposta stato su AC Nulla
        MOVWF b_DATA                        ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        RETURN

;_______________________________________________________Uscita PWM Positiva DC
;Imposta lo switcher su uscita DC positiva.
;In questa modalita' i drivers sono sganciati dal reference e
; le loro uscite sono basse. Questa posizione puo' essere mantenuta
; a tempo indeterminato.
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_DATA
;       b_ADDRESS
PWM_DCPos:
        MOVLF c_PWM_DCCVAL,b_PWM_STAT       ;Imposta stato su DC nulla
        MOVWF b_DATA                        ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        MOVLF c_PWM_DCPVAL,b_PWM_STAT       ;Imposta stato su DC Positiva
        MOVWF b_DATA                        ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        RETURN

;_______________________________________________________Uscita PWM Negativa DC
;Imposta lo switcher su uscita DC negativa.
;In questa modalita' i drivers sono sganciati dal reference e
; le loro uscite sono basse. Questa posizione puo' essere mantenuta
; a tempo indeterminato.
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_DATA
;       b_ADDRESS
PWM_DCNeg:
        MOVLF c_PWM_DCCVAL,b_PWM_STAT       ;Imposta stato su DC nulla
        MOVWF b_DATA                        ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        MOVLF c_PWM_DCNVAL,b_PWM_STAT       ;Imposta stato su DC Negativa
        MOVWF b_DATA                        ;Carica il dato
        MOVLF c_ADDR_PWR,b_ADDRESS          ;Seleziona indirizzo
        CALL IO_WRTDATA                     ;Scrive sul buffer
        RETURN

;_______________________________________________________Set duty PWM
;Imposta il duty del PWM nei registri appositi
;Dati in ingresso
;       su R0H va inserito il valore da impostare
;Registri modificati:
;       Sistema
;       R0H
PWM_Set:
        BTFSC R0H,0                         ;Verifica LSB
        GOTO PWM_S1                         ; 1
        BCF CCP1CON,4                       ; 0, clear bit CCP1CON
        GOTO PWM_S2                         ;
PWM_S1  BSF CCP1CON,4                       ; set bit CCP1CON
PWM_S2  BTFSC R0H,1                         ;Verifica Bit 1
        GOTO PWM_S3                         ; 1
        BCF CCP1CON,5                       ; 0, clear bit CCP1CON
        GOTO PWM_S4                         ;
PWM_S3  BSF CCP1CON,5                       ; set bit CCP1CON
PWM_S4  CLRC                                ;
        RRF R0H,f                           ;
        CLRC                                ;
        RRF R0H,f                           ;
        MOVFF R0H,CCPR1L                    ;Il resto va su CCPR1L
        RETURN

;_______________________________________________________Set duty PWM DC
;Imposta il duty del PWM nei registri appositi.
;La versione DC invece di impostare direttamente il dato, lo incrementa da 0
;Dati in ingresso
;       su R0H va inserito il valore da impostare
;Registri modificati:
;       Sistema
;       R0H
;       R2H
;       R2L
PWMD_Set:
        CLRF R2H                            ;
PWMD_S0 BTFSC R2H,0                         ;Verifica LSB
        GOTO PWMD_S1                        ; 1
        BCF CCP1CON,4                       ; 0, clear bit CCP1CON
        GOTO PWMD_S2                        ;
PWMD_S1 BSF CCP1CON,4                       ; set bit CCP1CON
PWMD_S2 BTFSC R2H,1                         ;Verifica Bit 1
        GOTO PWMD_S3                        ; 1
        BCF CCP1CON,5                       ; 0, clear bit CCP1CON
        GOTO PWMD_S4                        ;
PWMD_S3 BSF CCP1CON,5                       ; set bit CCP1CON
PWMD_S4 MOVFF R2H,R2L
        CLRC                                ;Gli altri bit vanno su CCPR1L
        RRF R2H,F                           ; quindi rimuovo i 2 LSBit e
        CLRC                                ; copio il resto nel registro
        RRF R2H,F                           ;
        MOVFF R2H,CCPR1L                    ;
        MOVFF R2L,R2H                       ;
        MOVF R0H,w                          ;
        SUBWF R2H,w                         ;
        BTFSC STATUS,Z                      ;
        RETURN
        INCF R2H,f                          ;
        GOTO PWMD_S0                        ;
        RETURN

;_______________________________________________________Set duty PWM DC a 0
;Imposta il duty del PWM a 0.
;Dati in ingresso
;Registri modificati:
;       Sistema
PWMD_Clr:
        BCF CCP1CON,4                       ;clear bit CCP1CON
        BCF CCP1CON,5                       ;clear bit CCP1CON
        CLRF CCPR1L                         ;
        RETURN

;_______________________________________________________Gestione sinusoide AC
;Gestisce la sinusoide quantizzata
;ATTENZIONE: Le tempistiche sono molto ristrette, e viene utilizzato un timer
; apposito (TIMER1):
; 0,00 -  0,75ms:   0%
; 0,75 -  1,75ms:  33%
; 1,75 -  3,25ms:  66%
; 3,25 -  6,75ms: 100%
; 6,75 -  8,25ms:  66%
; 8,25 -  9,25ms:  33%
; 9,25 - 10,00ms:   0%
;
;Dati in ingresso
;       b_PWM_DATA1,2,3 deve contenere i set point per i valori desiderati
;Registri modificati:
;       Sistema
;       b_PWM_STAT
;       b_SYN_CTRL
;       b_DATA
;       b_ADDRESS
PWM_ACSin:
        BCF f_IRQ_TIMER0_ON                 ;Clear flag IRQ Timer0
PWM_P00 BTFSC b_SYN_CTRL,0                  ;controlla se si trova nel primo stato (0%)
        GOTO PWM_P0A                        ; si
        BTFSS b_SYN_CTRL,7                  ;controlla se si trova nell'ottavo stato (0%)
        GOTO PWM_P01                        ; no, prosegue
PWM_P0A ADDLF c_TMR0_TIME1,TMR0             ; si, reimposta durata Timer0
        CLRF R0H                            ;carica valore PWM 0%
        GOTO PWM_AC1
PWM_P01 BTFSC b_SYN_CTRL,1                  ;controlla se si trova nel secondo stato (33%)
        GOTO PWM_P0B                        ; si
        BTFSS b_SYN_CTRL,6                  ;controlla se si trova nel settimo stato (100%)
        GOTO PWM_P02                        ; no, prosegue
PWM_P0B ADDLF c_TMR0_TIME2,TMR0             ; si, reimposta durata Timer0
        MOVFF b_PWM_DATA1,R0H               ;carica valore PWM 33%
        GOTO PWM_AC1
PWM_P02 BTFSS b_SYN_CTRL,2                  ;controlla se si trova nel terzo stato (66%)
        GOTO PWM_P03                        ; no, prosegue
PWM_P2A ADDLF c_TMR0_TIME3,TMR0             ; si, reimposta durata Timer0
        MOVFF b_PWM_DATA2,R0H               ;carica valore PWM 66%
        GOTO PWM_AC1
PWM_P03 BTFSC b_SYN_CTRL,3                  ;controlla se si trova nel quarto stato (100%)
        GOTO PWM_P0C                        ; si
        BTFSS b_SYN_CTRL,4                  ;controlla se si trova nel quinto stato (100%)
        GOTO PWM_P05                        ; no, prosegue
PWM_P0C NOP
        BANKSEL OPTION_REG
        BSF OPTION_REG,PS0                  ; si, cambia prescaler Timer0 a 64
        BANKSEL TMR0
        ADDLF c_TMR0_TIME4,TMR0             ; si, reimposta durata Timer0
        MOVFF b_PWM_DATA3,R0H               ;carica valore PWM 100%
        GOTO PWM_AC1
PWM_P05 BTFSS b_SYN_CTRL,5                  ;controlla se si trova nel sesto stato (66%)
        GOTO PWM_PEE                        ; no, prosegue
        BANKSEL OPTION_REG
        BCF OPTION_REG,PS0                  ; si, cambia prescaler Timer0 a 32
        BANKSEL TMR0
        GOTO PWM_P2A                        ;ripete passo 2
PWM_PEE MOVLF 0x01,b_SYN_CTRL               ;non dovrebbe finire qui. Resetta lo stato del PWM
        GOTO PWM_P00                        ;riparte dal passo 0
PWM_AC1 CLRC                                ; imposta stato successivo
        BTFSC b_SYN_CTRL,7                  ;controlla se si trova nell'ottavo stato
        SETC                                ; si, setta carry per ripristinare valore iniziale
        RLF b_SYN_CTRL,f                    ; no
        BTFSS f_PWM_POS                     ;verifica se uscita positiva o negativa
	GOTO PWM_AC2                        ; negativa
        BTFSC f_PWM_AC_INV                  ;controlla se deve gestire inversione AC
        CALL PWM_ACClr                      ;si, prima azzera uscita (evita corti)
        CALL PWM_ACPos                      ; positiva
        GOTO PWM_AC3
PWM_AC2 BTFSC f_PWM_AC_INV                  ;controlla se deve gestire inversione AC
        CALL PWM_ACClr                      ;si, prima azzera uscita (evita corti)
        CALL PWM_ACNeg
PWM_AC3 CALL PWM_Set                        ;setta PWM
        BTFSS b_SYN_CTRL,0                  ;Verifica se deve invertire uscita
        RETURN                              ; no
        BSF f_PWM_AC_INV                    ; si, inverte uscita
        BTFSC f_PWM_POS                     ;
        GOTO PWM_AC4                        ;
        BSF f_PWM_POS                       ; negativa, passa a positiva
        BCF f_PWM_NEG                       ;
        RETURN
PWM_AC4 BCF f_PWM_POS                       ; positiva, passa a negativa
        BSF f_PWM_NEG                       ;
        RETURN
