;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |        Include per gestione I/O 877          |
; |______________________________________________|
; |   Include File                               |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 31/03/09                       |
; |______________________________________________|

;_______________________________________________________Variabili
        BYTE b_DATA                         ;byte dati
        BYTE b_ADDRESS                      ;byte indirizzi
        BYTE b_OUT_ST                       ;byte stato blocco OUT
        BYTE b_IN_ST                        ;byte stato blocco IN

;_______________________________________________________Costanti
;PORTA
#define c_TRISA_VALUE   0x3F                ;PORTA: 0-5      analogiche IN

;PORTB
#define c_TRISB_VALUE   0xC1                ;PORTB: 0 INT    interrupt principale IN
                                            ;       1 PRL    retroilluminazione display OUT (unused)
                                            ;       2 CK     clock periferiche OUT
                                            ;       3 OE     output enable address buffer OUT
                                            ;       4 R/W    modalita' bus display OUT (unused)
                                            ;       5 RS     comunucazione display OUT (unused)
                                            ;       6 PGC    ICD2 IN
                                            ;       7 PGD    ICD2 IN
#define c_PRL_TRIS      TRISB               ;pin PRL
#define c_PRL_PORT      PORTB
#define c_PRL_PIN       1
#define c_CK_TRIS       TRISB               ;pin CK periferiche
#define c_CK_PORT       PORTB
#define c_CK_PIN        2
#define c_OE_TRIS       TRISB               ;pin OE address
#define c_OE_PORT       PORTB
#define c_OE_PIN        3
#define c_DRW_TRIS      TRISB               ;pin R/W display
#define c_DRW_PORT      PORTB
#define c_DRW_PIN       4
#define c_DDS_TRIS      TRISB               ;pin RS display
#define c_DDS_PORT      PORTB
#define c_DDS_PIN       5

;PORTC
#define c_TRISC_VALUE   0x80                ;PORTC: 0 S0     LSN indirizzi OUT
                                            ;       1 CCP2   PWM-2 OUT (unused)
                                            ;       2 CCP1   PWM-1 OUT
                                            ;       3 S1     indirizzi OUT
                                            ;       4 S2     indirizzi OUT
                                            ;       5 S3     MSN indirizzi OUT
                                            ;       6 TX_232 trasmissione seriale OUT
                                            ;       7 RX_232 ricezione seriale IN

#define c_S0_TRIS       TRISC               ;pin S0 indirizzi
#define c_S0_PORT       PORTC
#define c_S0_PIN        0

#define c_DBG_TRIS      TRISC               ;pin PORTC,1
#define c_DBG_PORT      PORTC
#define c_DBG_PIN       1

#define c_S1_TRIS       TRISC               ;pin S1 indirizzi
#define c_S1_PORT       PORTC
#define c_S1_PIN        3
#define c_S2_TRIS       TRISC               ;pin S2 indirizzi
#define c_S2_PORT       PORTC
#define c_S2_PIN        4
#define c_S3_TRIS       TRISC               ;pin S3 indirizzi
#define c_S3_PORT       PORTC
#define c_S3_PIN        5

;PORTD
#define c_TRISDO_VALUE  0x00                ;PORTD: 0-7      bus dati OUT
#define c_TRISDI_VALUE  0xFF                ;PORTD: 0-7      bus dati IN
#define c_TRISDK_VALUE  0xF0                ;PORTD: 0-3      bus dati OUT
                                            ;       4-7      bus dati IN

;PORTE
#define c_TRISE_VALUE   0x01                ;PORTE: 0        analogiche IN
                                            ;       1 DBG    debug OUT
                                            ;       2 OEP    output enable periferiche OUT

#define c_OEP_TRIS      TRISE               ;pin OE periferiche
#define c_OEP_PORT      PORTE
#define c_OEP_PIN       2

;INDIRIZZI
#define c_ADDR0_MASK    0xC6                ; maschera di azzeramento indirizzi

#define c_ADDR_IDLE     .0                  ;indirizzo "IDLE"
#define c_ADDR_KEYB     .2                  ;indirizzo tastiera
#define c_ADDR_DDATA    .3                  ;indirizzo Dati Dispay
#define c_ADDR_DSEL     .4                  ;indirizzo Selezione Display
#define c_ADDR_OUT      .5                  ;indirizzo scheda Out
#define c_ADDR_IN       .6                  ;indirizzo scheda In
#define c_ADDR_PWR      .7                  ;indirizzo scheda PWM


;_______________________________________________________FLAGS
#define f_S0_BIT        b_ADDRESS,0
#define f_S1_BIT        b_ADDRESS,1
#define f_S2_BIT        b_ADDRESS,2
#define f_S3_BIT        b_ADDRESS,3
